#!/usr/bin/env ruby

##### Gallery Creator CIP Version ########
# How to Use: Put this script in a directory. 
# Create a subdirectory called tmp. Put some JPEG 
# pictures in the tmp-direcotry. Run the script from the
# command line using: 
# ruby galleryCreatorCIP.rb
# As result you will get an gallery.html file. Open it 
# with your favorite browser

$start = Time.now()
# needed for html
require 'cgi'
require 'stringio'
require 'ftools'
UPLOAD_DIR = "./tmp"
CONVERT_PATH = "/usr/bin/convert"

UPLOAD_TEMPLATE = <<eot
<?xml version="1.0" encoding="ISO-8859-1" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
       "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<html><head><title>Gallery View (Ruby)</title>
</head><body><h1>Gallery View (Ruby)</h1>
eot

def createThumbnails(path)
	allFiles = Dir.entries(path)
	imageFiles = allFiles.find_all{|item| item =~ /\.jpg$/ && !(item =~ /^\./) && !(item =~ /_T\.jpg$/)}
	imageFiles.each do |f|
		inputfile = path+"/"+f
 		f =~ /(.*)\.jpg$/
		outputfile = path+"/"+$1+"_T.jpg"
		cmd = CONVERT_PATH+" -resize 100x100 "+inputfile+" "+outputfile
		File.delete(inputfile) if (!system(cmd))
	end
end
# 	
def generateWebsite(path)
 	html = UPLOAD_TEMPLATE
	allFiles = Dir.entries(path)
	imageFiles = allFiles.find_all{|item| item =~ /\.jpg$/ && !(item =~ /^\./) && !(item =~ /_T\.jpg$/)}
	imageFiles.each do |f|
 		inputfile = path+"/"+f
 		f =~ /(.*)\.jpg$/
		outputfile = path+"/"+$1+"_T.jpg"
 		html += '<div class="image"><a href="'
 		html += inputfile
 		html += '"><img src="'
 		html += outputfile
 		html += '"/></a></div>'
	end
	html += "Create thumbnails: %f seconds<br/>" % ($timeThumbnails)
	$timeHtml = Time.now()-$start
	html += "Write HTML: %f seconds<br/>" % ($timeHtml-$timeThumbnails)
 	html += "Overall: %f seconds<br/>" % $timeHtml
 	html += """</body></html>"""
	return html
end

# wir haben ein command line argument!
puts "Command line CIP pool version"
createThumbnails(UPLOAD_DIR)
$timeThumbnails = Time.now()-$start
html = generateWebsite(UPLOAD_DIR)
File.open("gallery.html", 'w') {|f| f.write(html) }



